// **********************************************************************
//
// Generated by the ORBacus IDL-to-C++ Translator
//
// Copyright (c) 2001
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

// Version: 4.1.1

#ifndef __OB_CosTime_h__
#define __OB_CosTime_h__

#ifndef OB_TIME_IMPORT
#   ifdef OB_DLL
#      define OB_TIME_IMPORT __declspec(dllimport)
#   else
#      define OB_TIME_IMPORT /**/
#   endif
#endif


#include <OB/TimeBase.h>

#ifndef OB_INTEGER_VERSION
#   error No ORBacus version defined! Is <OB/CORBA.h> included?
#endif

#ifndef OB_NO_VERSION_CHECK
#   if (OB_INTEGER_VERSION != 4010100L)
#       error ORBacus version mismatch!
#   endif
#endif

namespace CosTime
{

class UTO;
typedef UTO* UTO_ptr;
typedef UTO* UTORef;

class TIO;
typedef TIO* TIO_ptr;
typedef TIO* TIORef;

class TimeService;
typedef TimeService* TimeService_ptr;
typedef TimeService* TimeServiceRef;

} // End of namespace CosTime

void OBDuplicate(CosTime::UTO_ptr);
void OBRelease(CosTime::UTO_ptr);

void OBMarshal(CosTime::UTO_ptr, OB::OutputStreamImpl*);
void OBUnmarshal(CosTime::UTO_ptr&, OB::InputStreamImpl*);

void OBDuplicate(CosTime::TIO_ptr);
void OBRelease(CosTime::TIO_ptr);

void OBMarshal(CosTime::TIO_ptr, OB::OutputStreamImpl*);
void OBUnmarshal(CosTime::TIO_ptr&, OB::InputStreamImpl*);

void OBDuplicate(CosTime::TimeService_ptr);
void OBRelease(CosTime::TimeService_ptr);

void OBMarshal(CosTime::TimeService_ptr, OB::OutputStreamImpl*);
void OBUnmarshal(CosTime::TimeService_ptr&, OB::InputStreamImpl*);

namespace CosTime
{

typedef OB::ObjVar< UTO > UTO_var;
typedef OB::ObjOut< UTO > UTO_out;

typedef OB::ObjVar< TIO > TIO_var;
typedef OB::ObjOut< TIO > TIO_out;

typedef OB::ObjVar< TimeService > TimeService_var;
typedef OB::ObjOut< TimeService > TimeService_out;

} // End of namespace CosTime

namespace OBStubImpl_CosTime
{

} // End of namespace OBStubImpl_CosTime

namespace OBStubImpl_CosTime
{

} // End of namespace OBStubImpl_CosTime

//
// IDL:omg.org/CosTime:1.0
//
namespace CosTime
{

//
// IDL:omg.org/CosTime/TimeComparison:1.0
//
enum TimeComparison
{
    TCEqualTo,
    TCLessThan,
    TCGreaterThan,
    TCIndeterminate
};

typedef TimeComparison& TimeComparison_out;

//
// IDL:omg.org/CosTime/ComparisonType:1.0
//
enum ComparisonType
{
    IntervalC,
    MidC
};

typedef ComparisonType& ComparisonType_out;

//
// IDL:omg.org/CosTime/OverlapType:1.0
//
enum OverlapType
{
    OTContainer,
    OTContained,
    OTOverlap,
    OTNoOverlap
};

typedef OverlapType& OverlapType_out;

//
// IDL:omg.org/CosTime/TimeUnavailable:1.0
//
struct TimeUnavailable : public CORBA::UserException
{
    TimeUnavailable() { }
    TimeUnavailable(const TimeUnavailable&);
    TimeUnavailable& operator=(const TimeUnavailable&);

    static TimeUnavailable* _downcast(CORBA::Exception*);
    static const TimeUnavailable* _downcast(const CORBA::Exception*);
    virtual const char* _name() const;
    virtual void _raise() const { throw *this; }
    virtual const char* _rep_id() const;
    virtual char* _to_string() const;

    virtual CORBA::Exception* _OB_clone() const;
    virtual void _OB_insertInAny(CORBA::Any&);

    static void _OB_unmarshal(TimeUnavailable&, OB::InputStreamImpl*);
};

//
// IDL:omg.org/CosTime/UTO:1.0
//
class UTO : virtual public CORBA::Object
{
    UTO(const UTO&);
    void operator=(const UTO&);

protected:

    static OB_TIME_IMPORT const char* ids_[];

public:

    UTO() { }
    virtual ~UTO() { }

    typedef UTO_ptr _ptr_type;
    typedef UTO_var _var_type;

    static inline UTO_ptr
    _duplicate(UTO_ptr p)
    {
        if(p)
            p -> _add_ref();
        return p;
    }

    static inline UTO_ptr
    _nil()
    {
        return 0;
    }

    static UTO_ptr _narrow(CORBA::Object_ptr);

    static UTO_ptr _narrow(CORBA::AbstractBase_ptr);


    //
    // IDL:omg.org/CosTime/UTO/time:1.0
    //
    virtual ::TimeBase::TimeT time() = 0;

    //
    // IDL:omg.org/CosTime/UTO/inaccuracy:1.0
    //
    virtual ::TimeBase::InaccuracyT inaccuracy() = 0;

    //
    // IDL:omg.org/CosTime/UTO/tdf:1.0
    //
    virtual ::TimeBase::TdfT tdf() = 0;

    //
    // IDL:omg.org/CosTime/UTO/utc_time:1.0
    //
    virtual ::TimeBase::UtcT utc_time() = 0;

    //
    // IDL:omg.org/CosTime/UTO/absolute_time:1.0
    //
    virtual UTO_ptr absolute_time() = 0;

    //
    // IDL:omg.org/CosTime/UTO/compare_time:1.0
    //
    virtual TimeComparison compare_time(ComparisonType comparison_type,
                                        UTO_ptr uto) = 0;

    //
    // IDL:omg.org/CosTime/UTO/time_to_interval:1.0
    //
    virtual TIO_ptr time_to_interval(UTO_ptr uto) = 0;

    //
    // IDL:omg.org/CosTime/UTO/interval:1.0
    //
    virtual TIO_ptr interval() = 0;
};

//
// IDL:omg.org/CosTime/TIO:1.0
//
class TIO : virtual public CORBA::Object
{
    TIO(const TIO&);
    void operator=(const TIO&);

protected:

    static OB_TIME_IMPORT const char* ids_[];

public:

    TIO() { }
    virtual ~TIO() { }

    typedef TIO_ptr _ptr_type;
    typedef TIO_var _var_type;

    static inline TIO_ptr
    _duplicate(TIO_ptr p)
    {
        if(p)
            p -> _add_ref();
        return p;
    }

    static inline TIO_ptr
    _nil()
    {
        return 0;
    }

    static TIO_ptr _narrow(CORBA::Object_ptr);

    static TIO_ptr _narrow(CORBA::AbstractBase_ptr);


    //
    // IDL:omg.org/CosTime/TIO/time_interval:1.0
    //
    virtual ::TimeBase::IntervalT time_interval() = 0;

    //
    // IDL:omg.org/CosTime/TIO/spans:1.0
    //
    virtual OverlapType spans(UTO_ptr time,
                              TIO_out overlap) = 0;

    //
    // IDL:omg.org/CosTime/TIO/overlaps:1.0
    //
    virtual OverlapType overlaps(TIO_ptr interval,
                                 TIO_out overlap) = 0;

    //
    // IDL:omg.org/CosTime/TIO/time:1.0
    //
    virtual UTO_ptr time() = 0;
};

//
// IDL:omg.org/CosTime/TimeService:1.0
//
class TimeService : virtual public CORBA::Object
{
    TimeService(const TimeService&);
    void operator=(const TimeService&);

protected:

    static OB_TIME_IMPORT const char* ids_[];

public:

    TimeService() { }
    virtual ~TimeService() { }

    typedef TimeService_ptr _ptr_type;
    typedef TimeService_var _var_type;

    static inline TimeService_ptr
    _duplicate(TimeService_ptr p)
    {
        if(p)
            p -> _add_ref();
        return p;
    }

    static inline TimeService_ptr
    _nil()
    {
        return 0;
    }

    static TimeService_ptr _narrow(CORBA::Object_ptr);

    static TimeService_ptr _narrow(CORBA::AbstractBase_ptr);


    //
    // IDL:omg.org/CosTime/TimeService/universal_time:1.0
    //
    virtual UTO_ptr universal_time() = 0;

    //
    // IDL:omg.org/CosTime/TimeService/secure_universal_time:1.0
    //
    virtual UTO_ptr secure_universal_time() = 0;

    //
    // IDL:omg.org/CosTime/TimeService/new_universal_time:1.0
    //
    virtual UTO_ptr new_universal_time(::TimeBase::TimeT time,
                                       ::TimeBase::InaccuracyT inaccuracy,
                                       ::TimeBase::TdfT tdf) = 0;

    //
    // IDL:omg.org/CosTime/TimeService/uto_from_utc:1.0
    //
    virtual UTO_ptr uto_from_utc(const ::TimeBase::UtcT& utc) = 0;

    //
    // IDL:omg.org/CosTime/TimeService/new_interval:1.0
    //
    virtual TIO_ptr new_interval(::TimeBase::TimeT lower,
                                 ::TimeBase::TimeT upper) = 0;
};

} // End of namespace CosTime

//
// IDL:omg.org/CosTime:1.0
//
namespace OBProxy_CosTime
{

} // End of namespace OBProxy_CosTime

//
// IDL:omg.org/CosTime:1.0
//
namespace OBStubImpl_CosTime
{

} // End of namespace OBStubImpl_CosTime

//
// IDL:omg.org/CosTime:1.0
//
namespace OBMarshalStubImpl_CosTime
{

} // End of namespace OBMarshalStubImpl_CosTime

//
// IDL:omg.org/CosTime:1.0
//
namespace OBV_CosTime
{

} // End of namespace OBV_CosTime

//
// IDL:omg.org/CosTime/UTO:1.0
//
namespace CORBA
{

inline void
release(::CosTime::UTO_ptr p)
{
    if(p)
        p -> _remove_ref();
}

inline Boolean
is_nil(::CosTime::UTO_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

//
// IDL:omg.org/CosTime/TIO:1.0
//
namespace CORBA
{

inline void
release(::CosTime::TIO_ptr p)
{
    if(p)
        p -> _remove_ref();
}

inline Boolean
is_nil(::CosTime::TIO_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

//
// IDL:omg.org/CosTime/TimeService:1.0
//
namespace CORBA
{

inline void
release(::CosTime::TimeService_ptr p)
{
    if(p)
        p -> _remove_ref();
}

inline Boolean
is_nil(::CosTime::TimeService_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

#endif
