static const char *RcsId = "$Header: /mntdirect/_segfs/tango/tools/pogo/templates/tango2/cpp/RCS/DevServ.cpp,v 1.2 2001/04/24 13:50:41 verdier Exp verdier $";
//+=============================================================================
//
// file :         TemplateDevServ.cpp
//
// description :  C++ source for the TemplateDevServ and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                TemplateDevServ are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author: verdier $
//
// $Revision: 1.2 $
//
// $Log: DevServ.cpp,v $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//             (c) - Pascal Verdier - ESRF
//=============================================================================

#include <tango.h>
#include <TemplateDevServ.h>

namespace TemplateDevServ
{

//+----------------------------------------------------------------------------
//
// method : 		TemplateDevServ::TemplateDevServ(string &s)
// 
// description : 	constructor for simulated TemplateDevServ
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
TemplateDevServ::TemplateDevServ(Tango::DeviceClass *cl,string &s):Tango::DeviceImpl(cl,s.c_str())
{
	init_device();
}

TemplateDevServ::TemplateDevServ(Tango::DeviceClass *cl,const char *s):Tango::DeviceImpl(cl,s)
{
	init_device();
}

TemplateDevServ::TemplateDevServ(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::DeviceImpl(cl,s,d)
{
	init_device();
}

void TemplateDevServ::init_device()
{
	cout << "TemplateDevServ::TemplateDevServ() create device " << device_name << endl;

	// Initialise variables to default values
	//--------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		TemplateDevServ::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void TemplateDevServ::always_executed_hook()
{

	cout2 << "In always_executed_hook method" << endl;
	
}

}	// namespace TemplateDevServ
